package model

import "github.com/shopspring/decimal"

type EndUserDetail struct {
	CreatedAndModified       `xorm:"extends"`
	ReportId                 string              `xorm:"varchar(120) pk not null" json:"-"`
	MeterId                  string              `xorm:"meter_04kv_id varchar(120) pk not null" json:"meterId"`
	Seq                      int64               `xorm:"bigint not null" json:"seq"`
	Ratio                    decimal.Decimal     `xorm:"numeric(8,4) not null" json:"ratio"`
	LastPeriodCritical       decimal.NullDecimal `xorm:"numeric(14,2)" json:"lastPeriodCritical"`
	LastPeriodPeek           decimal.NullDecimal `xorm:"numeric(14,2)" json:"lastPeriodPeek"`
	LastPeriodFlat           decimal.Decimal     `xorm:"numeric(14,2) not null" json:"lastPeriodFlat"`
	LastPeriodValley         decimal.NullDecimal `xorm:"numeric(14,2)" json:"lastPeriodValley"`
	CurrentPeriodCritical    decimal.NullDecimal `xorm:"numeric(14,2)" json:"currentPeriodCritical"`
	CurrentPeriodPeek        decimal.NullDecimal `xorm:"numeric(14,2)" json:"currentPeriodPeek"`
	CurrentPeriodFlat        decimal.Decimal     `xorm:"numeric(14,2) not null" json:"currentPeriodFlat"`
	CurrentPeriodValley      decimal.NullDecimal `xorm:"numeric(14,2)" json:"currentPeriodValley"`
	AdjustCritical           decimal.NullDecimal `xorm:"numeric(14,2)" json:"adjustCritical"`
	AdjustPeek               decimal.NullDecimal `xorm:"numeric(14,2)" json:"adjustPeek"`
	AdjustFlat               decimal.Decimal     `xorm:"numeric(14,2) not null" json:"adjustFlat"`
	AdjustValley             decimal.NullDecimal `xorm:"numeric(14,2)" json:"adjustValley"`
	Critical                 decimal.NullDecimal `xorm:"numeric(14,2)" json:"critical"`
	CriticalFee              decimal.NullDecimal `xorm:"numeric(18,8)" json:"criticalFee"`
	Peek                     decimal.NullDecimal `xorm:"numeric(14,2)" json:"peek"`
	PeekFee                  decimal.NullDecimal `xorm:"numeric(18,8)" json:"peekFee"`
	Flat                     decimal.Decimal     `xorm:"numeric(14,2) not null" json:"flat"`
	FlatFee                  decimal.Decimal     `xorm:"numeric(18,8) not null" json:"flatFee"`
	Valley                   decimal.NullDecimal `xorm:"numeric(14,2)" json:"valley"`
	ValleyFee                decimal.NullDecimal `xorm:"numeric(18,8)" json:"valleyFee"`
	BasicFeeDiluted          decimal.NullDecimal `xorm:"numeric(18,8)" json:"basicFeeDiluted"`
	AdjustFeeDiluted         decimal.NullDecimal `xorm:"numeric(18,8)" json:"adjustFeeDiluted"`
	LossDiluted              decimal.NullDecimal `xorm:"numeric(18,8)" json:"lossDiluted"`
	LossFeeDiluted           decimal.NullDecimal `xorm:"numeric(18,8)" json:"lossFeeDiluted"`
	MaintenanceFeeDiluted    decimal.NullDecimal `xorm:"numeric(18,8)" json:"maintenanceFeeDiluted"`
	PublicConsumptionDiluted decimal.NullDecimal `xorm:"numeric(18,8)" json:"publicConsumptionDiluted"`
	ServiceFeeDiluted        decimal.NullDecimal `xorm:"numeric(18,8)" json:"serviceFeeDiluted"`
	FinalCharge              decimal.NullDecimal `xorm:"numeric(14,2)" json:"finalCharge"`
}

func (EndUserDetail) TableName() string {
	return "end_user_detail"
}
